#
# Conditional build:
%bcond_without	nvidia_settings	# build the main package
%bcond_without	utils	# build utils from samples dir
%bcond_without	libXNVCtrl	# build libXNVCtrl for http://websvn.kde.org/trunk/kdenonbeta/nvidia/

Summary:	Tool for configuring the NVIDIA driver
Summary(pl.UTF-8):	Narzędzie do konfigurowania sterownika NVIDIA
Name:		nvidia-settings
# keep the version in sync with xorg-driver-video-nvidia.spec
Version:	331.20
Release:	1
License:	GPL
Group:		X11
Source0:	ftp://download.nvidia.com/XFree86/nvidia-settings/%{name}-%{version}.tar.bz2
# Source0-md5:	bbe5b7beaedb274d4dc81640f8e561ce
Source1:	%{name}.desktop
Source2:	%{name}.png
Source3:	%{name}-autostart.desktop
URL:		ftp://download.nvidia.com/XFree86/nvidia-settings/
BuildRequires:	OpenGL-devel
BuildRequires:	libvdpau-devel
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXv-devel
BuildRequires:	xorg-lib-libXxf86vm-devel
%if %{with nvidia_settings}
BuildRequires:	gtk+2-devel
BuildRequires:	m4
BuildRequires:	pkgconfig
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The nvidia-settings utility is a tool for configuring the NVIDIA Linux
graphics driver. It operates by communicating with the NVIDIA X
driver, querying and updating state as appropriate. This communication
is done with the NV-CONTROL X extension.

Values such as brightness and gamma, XVideo attributes, temperature,
and OpenGL settings can be queried and configured via nvidia-settings.

When nvidia-settings starts, it reads the current settings from its
configuration file and sends those settings to the X server. Then, it
displays a graphical user interface (GUI) interface for configuring
the current settings. When nvidia-settings exits, it queries the
current settings from the X server and saves them to the configuration
file.

%description -l pl.UTF-8
Narzędzie nvidia-settings służy do konfiguracji sterownika do kart
graficznych firmy NVIDIA. Działa komunikując się ze sterownikiem X
NVIDIA, sprawdzając i uaktualniając stan w razie potrzeby. Komunikacja
odbywa się poprzez rozszerzenie X NV-CONTROL.

Za pomocą nvidia-settings można odczytywać i zmieniać wartości takie
jak jasność i korekcja gamma, atrybuty XVideo, temperatura barw i
ustawienia OpenGL.

Przy uruchamianiu nvidia-settings odczytuje bieżące ustawienia z pliku
konfiguracyjnego i wysyła te ustawienia do serwera X. Następnie
wyświetla graficzny interfejs użytkownika (GUI) do konfiguracji
ustawień. Przy wyłączniu nvidia-settings odczytuje bieżące ustawienia
z serwera X i zapisuje je do pliku konfiguracyjnego.

%package -n libXNVCtrl-devel
Summary:	libXNVCtrl development headers
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libXNVCtrl
Group:		Development/Libraries
Requires:	xorg-lib-libX11-devel
Requires:	xorg-lib-libXext-devel
Requires:	xorg-lib-libXxf86vm-devel
Obsoletes:	libXNVCtrl-static

%description -n libXNVCtrl-devel
Library for accessing NV-CONTROL extension in NVIDIA's latest drivers.

%description -n libXNVCtrl-devel -l pl.UTF-8
Biblioteka do obsługi rozszerzenia NV-CONTROL z najnowszych
sterowników NVIDIA.

%prep
%setup -q

%{__rm} src/libXNVCtrl/libXNVCtrl.a

%build
%if %{with libXNVCtrl}
%{__make} -C src/libXNVCtrl \
	NV_VERBOSE=1 \
	CC="%{__cc}" \
	X_CFLAGS="%{rpmcppflags} %{rpmcflags} -fPIC"
%endif

%if %{with utils}
%{__make} -C samples \
	NV_VERBOSE=1 \
	CC="%{__cc}" \
	OUTPUTDIR=$(pwd)/_out/utils \
	X_CFLAGS="%{rpmcppflags} %{rpmcflags} -fPIC"
%endif

%if %{with nvidia_settings}
%{__make} \
	NV_VERBOSE=1 \
	STRIP_CMD=: \
	CC="%{__cc}" \
	X_CFLAGS="%{rpmcppflags} %{rpmcflags}" \
	X_LDFLAGS="%{rpmldflags}"
%endif

%install
rm -rf $RPM_BUILD_ROOT
%if %{with nvidia_settings}
install -d $RPM_BUILD_ROOT{%{_bindir},%{_mandir}/man1,%{_desktopdir},%{_pixmapsdir},/etc/xdg/autostart}
%{__make} install \
	INSTALL="install -p" \
	PREFIX=%{_prefix} \
	DESTDIR=$RPM_BUILD_ROOT
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_desktopdir}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_pixmapsdir}
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/xdg/autostart/%{name}.desktop
%endif

%if %{with libXNVCtrl}
install -d $RPM_BUILD_ROOT%{_examplesdir}/libXNVCtrl-%{version} \
	$RPM_BUILD_ROOT{%{_libdir},%{_includedir}/NVCtrl}
cp -a samples/* $RPM_BUILD_ROOT%{_examplesdir}/libXNVCtrl-%{version}
rm -r $RPM_BUILD_ROOT%{_examplesdir}/libXNVCtrl-%{version}/_out
cp -p src/libXNVCtrl/nv_control.h $RPM_BUILD_ROOT%{_includedir}/NVCtrl
cp -p src/libXNVCtrl/NVCtrl.h $RPM_BUILD_ROOT%{_includedir}/NVCtrl
cp -p src/libXNVCtrl/NVCtrlLib.h $RPM_BUILD_ROOT%{_includedir}/NVCtrl
cp -p src/libXNVCtrl/libXNVCtrl.a $RPM_BUILD_ROOT%{_libdir}

install -d $RPM_BUILD_ROOT%{_pkgconfigdir}
cat <<'EOF' > $RPM_BUILD_ROOT%{_pkgconfigdir}/libXNVCtrl.pc
prefix=%{_prefix}
libdir=%{_libdir}
includedir=${prefix}/include/NVCtrl

Name: libXNVCtrl
Description: Library for accessing NV-CONTROL extension in NVIDIA's latest drivers.
Version: %{version}
Libs: -L${libdir} -lXNVCtrl
Cflags: -I${includedir}
EOF
#'
%endif

%if %{with utils}
install -d $RPM_BUILD_ROOT%{_bindir}
for prog in _out/utils/nv-control-*; do
	case "$prog" in
	*.*)
		continue
		;;
	esac
	install -p $prog $RPM_BUILD_ROOT%{_bindir}
done
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with nvidia_settings}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/nvidia-settings
%{_mandir}/man1/nvidia-settings.1*
%{_desktopdir}/nvidia-settings.desktop
%{_pixmapsdir}/nvidia-settings.png
/etc/xdg/autostart/%{name}.desktop
%endif

%if %{with utils}
%attr(755,root,root) %{_bindir}/nv-control-3dvisionpro
%attr(755,root,root) %{_bindir}/nv-control-dpy
%attr(755,root,root) %{_bindir}/nv-control-dvc
%attr(755,root,root) %{_bindir}/nv-control-events
%attr(755,root,root) %{_bindir}/nv-control-framelock
%attr(755,root,root) %{_bindir}/nv-control-gvi
%attr(755,root,root) %{_bindir}/nv-control-info
%attr(755,root,root) %{_bindir}/nv-control-targets
%attr(755,root,root) %{_bindir}/nv-control-warpblend
%endif

%if %{with libXNVCtrl}
%files -n libXNVCtrl-devel
%defattr(644,root,root,755)
%doc doc/{FRAMELOCK,NV-CONTROL-API}.txt
%{_libdir}/libXNVCtrl.a
%{_includedir}/NVCtrl
%{_pkgconfigdir}/libXNVCtrl.pc
%{_examplesdir}/libXNVCtrl-%{version}
%endif
%changelog
* Wed Nov 06 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nvidia-settings.git;a=log;h=master

* Wed Nov 06 2013 Jan Palus <jan.palus@gmail.com> f9065c6
- up to 331.20

* Fri Oct 04 2013 Lukasz Glebicki <blekot@pld-linux.org> 121a3ee
- up to 325.15
- updated patch for format-security taken from Debian:
  http://patch-tracker.debian.org/patch/series/dl/nvidia-settings/325.15-1/08_fix_format-security.diff

* Sun Sep 29 2013 Elan Ruusamäe <glen@delfi.ee> 9b9b862
- fix messed up -Wsecurity patch from 5fa39bf

* Sun Sep 29 2013 Elan Ruusamäe <glen@delfi.ee> 987f172
- up to 319.49 (sync with xorg-driver-video-nvidia)

* Sat Jun 29 2013 Lukasz Glebicki <blekot@pld-linux.org> 5fa39bf
- up to 319.32
- added huge patch: nvidia-settings-wsecurity.patch for format not a
  string literal and no format arguments [-Werror=format-security]
  error

* Tue Jun 04 2013 Jan Rękorajski <baggins@pld-linux.org> a844905
- up to 319.23

* Wed Apr 10 2013 Elan Ruusamäe <glen@delfi.ee> c7c6d26
- up to 313.30 (same as xorg-driver-video-nvidia)

* Tue Feb 19 2013 Elan Ruusamäe <glen@delfi.ee> 0f59380
- up to 310.32 (same as xorg-driver-video-nvidia)

* Sun Feb 17 2013 Elan Ruusamäe <glen@delfi.ee> a604bf4
- load nvidia-settings on startup

* Thu Jan 03 2013 Elan Ruusamäe <glen@delfi.ee> 958f068
- up to 310.19

* Tue Nov 20 2012 Elan Ruusamäe <glen@delfi.ee> 1e8822e
- up to 304.64

* Sun Oct 21 2012 Elan Ruusamäe <glen@delfi.ee> e7c6a80
- desc cosmetics

* Sun Oct 21 2012 Elan Ruusamäe <glen@delfi.ee> 702ac7b
- up to 304.43, same version as xorg-driver-video-nvidia

* Sun May 06 2012 Elan Ruusamäe <glen@pld-linux.org> 2dece98
- build nv-control utils

* Sun May 06 2012 Elan Ruusamäe <glen@pld-linux.org> 3917229
- up to 295.40, to match current HEAD@xorg-driver-video-nvidia

* Sun Mar 13 2011 Elan Ruusamäe <glen@pld-linux.org> b83fa72
- up to 270.30

* Sun Mar 13 2011 Elan Ruusamäe <glen@pld-linux.org> 1851a39
- add .desktop file from xorg-driver-video-nvidia package

* Mon Jun 14 2010 sparky <sparky@pld-linux.org> 8f44337
- use rpmcppflags

* Mon Jun 14 2010 sparky <sparky@pld-linux.org> da8b864
- proper linking, now -as-needed won't kick out butts

* Mon Jun 14 2010 Elan Ruusamäe <glen@pld-linux.org> 59b8d07
- up to 195.36.31, fix libs linking

